
#ifndef _APP_HOST_QUEUE_UART_H_
#define _APP_HOST_QUEUE_UART_H_

#include "pDebug.h"
#include "FreeRTOS.h"
#include "queue.h"
#include "uart_dev.h"

/* еݸʽ */
typedef struct _hostQueueUartSendInfo{
    uint32_t length;    //ݳ
    uint8_t *data;      //
} hostQueueUartSendInfo;
#define hostQueueUartSendInfoSize sizeof(hostQueueUartSendInfo)

extern QueueHandle_t J0_485_Queue;
extern QueueHandle_t J2_485_Queue;
extern QueueHandle_t J4_485_Queue;
extern QueueHandle_t J6_485_Queue;
extern QueueHandle_t lora_uart_Queue;
extern QueueHandle_t su806_uart_Queue;
extern QueueHandle_t hostMcu_uart_Queue;

uint8_t hostUartInterruptSend(device_handle device, uint8_t *data, uint16_t len);

void hostUartSendInit(void);

void hostBinarySemaphoreFreeMemory(void);

void J0QueueSend(void);
void J2QueueSend(void);
void J4QueueSend(void);
void J6QueueSend(void);
void LoraQueueSend(void);
void Su806QueueSend(void);
void HostMcuQueueSend(void);

void J0_485_IN_TXE(void);
void J2_485_IN_TXE(void);
void J4_485_IN_TXE(void);
void J6_485_IN_TXE(void);
void Lora_uart_IN_TXE(void);
void Su806_uart_IN_TXE(void);
void hostMcu_uart_IN_TXE(void);


#endif
