
#include "hostBusIdleDetection.h"

static TimerHandle_t J0_485_Swtmr = NULL;
static TimerHandle_t J2_485_Swtmr = NULL;
static TimerHandle_t J4_485_Swtmr = NULL;
static TimerHandle_t J6_485_Swtmr = NULL;

static void J0_485_tmrCallback(void* parameter);
static void J2_485_tmrCallback(void* parameter);
static void J4_485_tmrCallback(void* parameter);
static void J6_485_tmrCallback(void* parameter);

// ֵź
SemaphoreHandle_t J0_IDLESemaphore = NULL;
SemaphoreHandle_t J2_IDLESemaphore = NULL;
SemaphoreHandle_t J4_IDLESemaphore = NULL;
SemaphoreHandle_t J6_IDLESemaphore = NULL;

#define softwareDelay (30 / (1000 / configTICK_RATE_HZ))

void hostIdleInit(void)
{
    J0_485_Swtmr = xTimerCreate((const char*)"J0Timer",
                                softwareDelay,              //ʱ
                                (UBaseType_t )pdFALSE,      //ģʽ 
                                (void *)1,                  //ΪÿʱһΨһID
                                (TimerCallbackFunction_t)J0_485_tmrCallback);   //ص
    
    J2_485_Swtmr = xTimerCreate((const char*)"J2Timer",
                                softwareDelay,
                                (UBaseType_t )pdFALSE,
                                (void *)2,
                                (TimerCallbackFunction_t)J2_485_tmrCallback);
                                
    J4_485_Swtmr = xTimerCreate((const char*)"J4Timer",
                                softwareDelay,
                                (UBaseType_t )pdFALSE,
                                (void *)2,
                                (TimerCallbackFunction_t)J4_485_tmrCallback);
                                
    J6_485_Swtmr = xTimerCreate((const char*)"J6Timer",
                                softwareDelay,
                                (UBaseType_t )pdFALSE,
                                (void *)2,
                                (TimerCallbackFunction_t)J6_485_tmrCallback);

    J0_IDLESemaphore = xSemaphoreCreateBinary();
    xSemaphoreGive(J0_IDLESemaphore);
    J2_IDLESemaphore = xSemaphoreCreateBinary();
    xSemaphoreGive(J2_IDLESemaphore);
    J4_IDLESemaphore = xSemaphoreCreateBinary();
    xSemaphoreGive(J4_IDLESemaphore);
    J6_IDLESemaphore = xSemaphoreCreateBinary();
    xSemaphoreGive(J6_IDLESemaphore);
}

void J0_485_tmrCallback(void* parameter)
{
    xSemaphoreGiveFromISR(J0_IDLESemaphore, 0);
}
void J2_485_tmrCallback(void* parameter)
{
    xSemaphoreGiveFromISR(J2_IDLESemaphore, 0);
}
void J4_485_tmrCallback(void* parameter)
{
    xSemaphoreGiveFromISR(J4_IDLESemaphore, 0);
}
void J6_485_tmrCallback(void* parameter)
{
    xSemaphoreGiveFromISR(J6_IDLESemaphore, 0);
}

/*
 * @brief   ж
 * @param   
 * @retval
 *
 */
void J0_485_IN_IDLE(void)
{
    xTimerStartFromISR(J0_485_Swtmr, 0);
}
void J2_485_IN_IDLE(void)
{
    xTimerStartFromISR(J2_485_Swtmr, 0);
}
void J4_485_IN_IDLE(void)
{
    xTimerStartFromISR(J4_485_Swtmr, 0);
}
void J6_485_IN_IDLE(void)
{
    xTimerStartFromISR(J6_485_Swtmr, 0);
}

/*
 * @brief   жϺ󣬵һνж
 * @param   
 * @retval
 *
 */
void J0_485_IN_RXNE(void)
{
    xTimerStopFromISR(J0_485_Swtmr, 0);
    xSemaphoreTakeFromISR(J0_IDLESemaphore, 0);
}
void J2_485_IN_RXNE(void)
{
    xTimerStopFromISR(J2_485_Swtmr, 0);
    xSemaphoreTakeFromISR(J2_IDLESemaphore, 0);
}
void J4_485_IN_RXNE(void)
{
    xTimerStopFromISR(J4_485_Swtmr, 0);
    xSemaphoreTakeFromISR(J4_IDLESemaphore, 0);
}
void J6_485_IN_RXNE(void)
{
    xTimerStopFromISR(J6_485_Swtmr, 0);
    xSemaphoreTakeFromISR(J6_IDLESemaphore, 0);
}

