
#include "hostSensorDataParse.h"
#include "hostQueueUart.h"

#include "mcu_common.h"


/**
  * @brief  J0ڴ
  * @param 
  * @retval
  */
void J0_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J0_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J0_handle) == 1)
            && (maxdataLen > J0_485RxBufferIndex)) {
        J0_485RxBuffer[J0_485RxBufferIndex++] = uart_dev_in_char(g_J0_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J0_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + J0_485RxBufferIndex + hostQueueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J0_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        hostQueueUartSendInfo *sendBuff = (hostQueueUartSendInfo *)Buff;
        sendBuff->length = 6 + J0_485RxBufferIndex;
        sendBuff->data = Buff + sizeof(hostQueueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = J0;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J0_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J0_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J0_485RxBuffer, J0_485RxBufferIndex);

        /* ־ */
        send += J0_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(su806_uart_Queue)) {
            xQueueSend(su806_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        J0_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J2ڴ
  * @param 
  * @retval
  */
void J2_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J2_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J2_handle) == 1)
            && (maxdataLen > J2_485RxBufferIndex)) {
        J2_485RxBuffer[J2_485RxBufferIndex++] = uart_dev_in_char(g_J2_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J2_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + J2_485RxBufferIndex + hostQueueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J2_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        hostQueueUartSendInfo *sendBuff = (hostQueueUartSendInfo *)Buff;
        sendBuff->length = 6 + J2_485RxBufferIndex;
        sendBuff->data = Buff + sizeof(hostQueueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = J2;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J2_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J2_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J2_485RxBuffer, J2_485RxBufferIndex);

        /* ־ */
        send += J2_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(su806_uart_Queue)) {
            xQueueSend(su806_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        J2_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J4ڴ
  * @param 
  * @retval
  */
void J4_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J4_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J4_handle) == 1)
            && (maxdataLen > J4_485RxBufferIndex)) {
        J4_485RxBuffer[J4_485RxBufferIndex++] = uart_dev_in_char(g_J4_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J4_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + J4_485RxBufferIndex + hostQueueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J4_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        hostQueueUartSendInfo *sendBuff = (hostQueueUartSendInfo *)Buff;
        sendBuff->length = 6 + J4_485RxBufferIndex;
        sendBuff->data = Buff + sizeof(hostQueueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = J4;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J4_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J4_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J4_485RxBuffer, J4_485RxBufferIndex);

        /* ־ */
        send += J4_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(su806_uart_Queue)) {
            xQueueSend(su806_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        J4_485RxBufferIndex = 0;
    }
}

/**
  * @brief  J6ڴ
  * @param 
  * @retval
  */
void J6_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (J6_485RxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_J6_handle) == 1)
            && (maxdataLen > J6_485RxBufferIndex)) {
        J6_485RxBuffer[J6_485RxBufferIndex++] = uart_dev_in_char(g_J6_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((J6_485RxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + J6_485RxBufferIndex + hostQueueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            J6_485RxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        hostQueueUartSendInfo *sendBuff = (hostQueueUartSendInfo *)Buff;
        sendBuff->length = 6 + J6_485RxBufferIndex;
        sendBuff->data = Buff + sizeof(hostQueueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = J6;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(J6_485RxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(J6_485RxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)J6_485RxBuffer, J6_485RxBufferIndex);

        /* ־ */
        send += J6_485RxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(su806_uart_Queue)) {
            xQueueSend(su806_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        J6_485RxBufferIndex = 0;
    }
}

/**
  * @brief  Loraڴ
  * @param 
  * @retval
  */
void Lora_SensorDataAnalysis(void)
{
    static uint32_t tick;

    if (loraRxBufferIndex == 0) {
        tick = xTaskGetTickCount();
    }

    /* ν6ms3ʱڣ */
    uint32_t nowTick = xTaskGetTickCount();
    while ((getTickDiff(nowTick) < 3)
            && (uart_dev_char_present(g_Lora_handle) == 1)
            && (maxdataLen > loraRxBufferIndex)) {
        loraRxBuffer[loraRxBufferIndex++] = uart_dev_in_char(g_Lora_handle);
    }

    /* ʱ䵽ʹ͸ģ */
    if ((loraRxBufferIndex >= maxdataLen) || (getTickDiff(tick) > delayTick)) {
        uint32_t tempLen = 6 + loraRxBufferIndex + hostQueueUartSendInfoSize;
        if (xPortGetFreeHeapSize() < tempLen + 1024) {
            loraRxBufferIndex = 0;
            return;
        }

        uint8_t *Buff = (uint8_t *)pvPortMalloc(tempLen);
        hostQueueUartSendInfo *sendBuff = (hostQueueUartSendInfo *)Buff;
        sendBuff->length = 6 + loraRxBufferIndex;
        sendBuff->data = Buff + sizeof(hostQueueUartSendInfo);
        uint8_t *send = sendBuff->data;

        /* ʼ־ */
        *send = 'S';
        *(send + 1) = 'L';

        /* ˿ں */
        send += 2;
        *send = Lora;

        /* ݰ */
        send += 1;
        *send = (uint8_t)(loraRxBufferIndex >> 8);
        *(send + 1) = (uint8_t)(loraRxBufferIndex);

        /* ݰ */
        send += 2;
        memcpy((char *)send, (char *)loraRxBuffer, loraRxBufferIndex);

        /* ־ */
        send += loraRxBufferIndex;
        *send = 0x17;

        /* пռ䣬򽫷 */
        if (uxQueueSpacesAvailable(su806_uart_Queue)) {
            xQueueSend(su806_uart_Queue, &Buff, 10);
        }
        /* ޿ռ䣬ݶ */
        else {
            vPortFree(Buff);
        }

        /* ɻ⣬buffе */
        loraRxBufferIndex = 0;
    }
}





